C STEPHANE BALAC -- IRMAR -- MAI 1995
C DERNIERE MODIFICATION : 24 MAI 1995
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
C SUBROUTINES UTILITAIRES POUR ARGUMENTS DOUBLE PRECISION
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
      SUBROUTINE DPDTVE(U,V,W,N,IOPT)
C -----------------------------------------------------------------
C  RENVOI N = U X V    SI    IOPT = 1 
C    ET   N = P1P2 ^ P1P3   SI   IOPT = 2
C -----------------------------------------------------------------
      INTEGER I,IOPT
      DOUBLE PRECISION U(3),V(3),W(3),N(3),V1(3),V2(3)
     
      GOTO (10,20) IOPT
      STOP'ERROR 1 IN SB PDTVEC'
10    N(1)=U(2)*V(3)-U(3)*V(2)
      N(2)=U(3)*V(1)-U(1)*V(3)
      N(3)=U(1)*V(2)-U(2)*V(1)
      RETURN
20    DO 21 I=1,3
        V1(I)=V(I)-U(I)
        V2(I)=W(I)-U(I)
21    CONTINUE
      N(1)=V1(2)*V2(3)-V1(3)*V2(2)
      N(2)=V1(3)*V2(1)-V1(1)*V2(3)
      N(3)=V1(1)*V2(2)-V1(2)*V2(1)
 
      END

C ==========================================================================
      DOUBLE PRECISION FUNCTION DSCAL(P1,P2,P3,NDIM,IOPT)
C -----------------------------------------------------------------
C RENVOI #(P1-P2).#(P1-P3) SI IOPT = 1 (3 POINTS) 
C        #P1.#P2 SI IOPT = 2 (2 VECTEURS)
C        #(P1-P2).#P3   SI IOPT = 3 (2 POINTS ET 1 VECTEUR)
C NDIM = DIMENSION (2 OU 3)
C -----------------------------------------------------------------
      INTEGER NDIM,IOPT,I
      DOUBLE PRECISION P1(NDIM),P2(NDIM),P3(NDIM),VAL,U(3),V(3)

      VAL=0.D0
      GOTO (10,20,30) IOPT
      STOP 'ERROR 1 IN SB  SCAL'
C
10    DO 11 I=1,NDIM
       U(I) = P2(I)-P1(I)
       V(I) = P3(I)-P1(I)
11    CONTINUE
      GOTO 40
C
20    DO 21 I=1,NDIM
       U(I) = P1(I)
       V(I) = P2(I)
21    CONTINUE
      GOTO 40
C
30    DO 31 I=1,NDIM
       U(I) = P2(I)-P1(I)
       V(I) = P3(I)
31    CONTINUE
C
40    DO 41 I=1,NDIM     
41      VAL = VAL+U(I)*V(I)

      DSCAL = VAL
      END

C ==========================================================================
      SUBROUTINE DVECT(P1,P2,V,NDIM)
C -----------------------------------------------------------------
C RENVOI V=VECTEUR(P1-P2)
C -----------------------------------------------------------------
      DOUBLE PRECISION P1(NDIM),P2(NDIM),V(NDIM)
      INTEGER I,NDIM

      DO 10 I=1,NDIM
10      V(I)=P2(I)-P1(I)

      END
       
C ==========================================================================
       SUBROUTINE DRNORM(U,UNORM,IOPT)
C RENVOI UNORM = U / ||U||. U VECTEUR DE DIMENSION IOPT (2 OU 3)
      DOUBLE PRECISION U(IOPT),UNORM(IOPT),NORME
      INTEGER IOPT,I

      GOTO (20,30) (IOPT-1)
      STOP'ERROR 1 IN SB RNORM'
20    NORME = DSQRT(U(1)*U(1)+U(2)*U(2))
      GOTO 40
30    NORME = DSQRT(U(1)*U(1)+U(2)*U(2)+U(3)*U(3))     
40    IF (NORME.GT.1D-30) THEN
        DO 41 I=1,IOPT
41        UNORM(I) = U(I)/NORME
      ELSE
        DO 42 I=1,IOPT
42        UNORM(I) = 0.D0 
      ENDIF
      END

C ==================================================================
      DOUBLE PRECISION FUNCTION DDIST(Q1,Q2,NDIM)
C CALCUL LA DISTANCE Q1-Q2  DANS R2 SI NDIM=2 ; DANS R3 SI NDIM=3
      DOUBLE PRECISION Q1(NDIM),Q2(NDIM),D2
      INTEGER NDIM,I

      D2=0.D0
      DO 10 I=1,NDIM
10       D2=D2+(Q1(I)-Q2(I))**2

      DDIST=DSQRT(D2)

      END

C ==================================================================
      SUBROUTINE DCHGRP(P,A,E1,E2,P2D)  
C CETTE PROCEDURE CALCULE LES COORDONNEES DU POINT P QUI APPARTIENT AU 
C PLAN {A,E1,E2} DE R^3 DANS LE REPERE {A,E1,E2} LIE A CE PLAN .  

      DOUBLE PRECISION P(3),P2D(2),A(3),E1(3),E2(3),XOX,YOY,ZOZ
 
      XOX=P(1)-A(1)
      YOY=P(2)-A(2)
      ZOZ=P(3)-A(3)
      P2D(1)= XOX*E1(1) + YOY*E1(2) +ZOZ*E1(3)
      P2D(2)= XOX*E2(1) + YOY*E2(2) +ZOZ*E2(3)

      END

C ==================================================================
      INTEGER FUNCTION ISIGD(A)
C RENVOI 1 SI A >0 ET 0 SI A <0  => CODAGE DU SIGNE 
      DOUBLE PRECISION A  
      INTEGER IS

      IF (A.GT.0.D0) THEN
       IS = 1
      ELSE  
       IS = 0
      ENDIF
      ISIGD = IS

      END 

C ==================================================================
      DOUBLE PRECISION FUNCTION DSIG(I)  
C RENVOI -1 SI I = 0  ET 1 SI I = 1 => DECODAGE DU SIGNE 
      INTEGER I
       DOUBLE PRECISION RS
      IF (I.EQ.0) THEN
       RS = -1.D0
      ELSE  
       RS = 1.D0
      ENDIF
      DSIG = RS

      END 

C ================================================================== 
      SUBROUTINE DCHGREP(POLD,OOLD,XOLD,YOLD,ZOLD
     &                 ,PNEW,ONEW,XNEW,YNEW,ZNEW)
C
C STEPHANE BALAC - IRMAR - SEPTEMBRE 1996
C DERNIERE MODIFICATION: 12 SEPTEMBRE 1996
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
C ON DIPOSE DES COORDONNEES DU POINT POLD EXPRIMEES DANS LE REPERE 
C {OOLD,XOLD,YOLD,ZOLD}. ON VEUT LES COORDONNEES DE CE POINT DANS LE REPERE 
C {ONEW,XNEW,YNEW,ZNEW}. 
C LES POINTS  OOLD,ONEW ET LES VECTEURS XOLD,YOLD,ZOLD,XNEW,YNEW,ZNEW SONT
C EXPRIMES DANS UNE BASE COMMUNE {E1,E2,E3}
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
      DOUBLE PRECISION POLD(3),OOLD(3),XOLD(3),YOLD(3),ZOLD(3)
      DOUBLE PRECISION PNEW(3),ONEW(3),XNEW(3),YNEW(3),ZNEW(3)
      DOUBLE PRECISION E1(3),E2(3),E3(3),DEN,CST1,CST2,CST3
      DOUBLE PRECISION X1,X2,X3,Y1,Y2,Y3,Z1,Z2,Z3
      DOUBLE PRECISION XO1,XO2,XO3,YO1,YO2,YO3,ZO1,ZO2,ZO3


C ON CHERCHE L'EXPRESSION DES VECTEURS DE LA BASE DE REFERENCE EN 
C FONCTION DES VECTEUR DE LA NOUVELLE BASE
C
C A:=ARRAY([[X1,X2,X3],[Y1,Y2,Y3],[Z1,Z2,Z3]]);
C B:=ARRAY([X,Y,Z]);
C WITH(LINALG):LINSOLVE(A,B);
C
      X1 = XNEW(1)
      X2 = XNEW(2)
      X3 = XNEW(3)
      Y1 = YNEW(1)
      Y2 = YNEW(2)
      Y3 = YNEW(3)
      Z1 = ZNEW(1)
      Z2 = ZNEW(2)
      Z3 = ZNEW(3)
C      
      DEN = X1*Y2*Z3-X1*Z2*Y3-Y1*X2*Z3+Z2*Y1*X3-Y2*Z1*X3+Z1*X2*Y3
C      
      E1(1) = (Y2*Z3 - Z2*Y3)/DEN
      E1(2) = (X3*Z2 - X2*Z3)/DEN 
      E1(3) = (X2*Y3 - X3*Y2)/DEN
C
      E2(1) = (Y3*Z1 - Y1*Z3)/DEN
      E2(2) = (X1*Z3 - Z1*X3)/DEN
      E2(3) = (Y1*X3 - X1*Y3)/DEN
C
      E3(1) = (Z2*Y1 - Y2*Z1)/DEN
      E3(2) = (Z1*X2 - X1*Z2)/DEN
      E3(3) = (X1*Y2 - Y1*X2)/DEN
C     
      XO1 = XOLD(1)
      XO2 = XOLD(2)
      XO3 = XOLD(3)
      YO1 = YOLD(1)
      YO2 = YOLD(2)
      YO3 = YOLD(3)
      ZO1 = ZOLD(1)
      ZO2 = ZOLD(2)
      ZO3 = ZOLD(3)

      CST1 = OOLD(1) - ONEW(1) + POLD(1)*XO1 + POLD(2)*YO1 + POLD(3)*ZO1
      CST2 = OOLD(2) - ONEW(2) + POLD(1)*XO2 + POLD(2)*YO2 + POLD(3)*ZO2
      CST3 = OOLD(3) - ONEW(3) + POLD(1)*XO3 + POLD(2)*YO3 + POLD(3)*ZO3     
      
      PNEW(1) = CST1*E1(1) +CST2*E2(1) + CST3*E3(1)
      PNEW(2) = CST1*E1(2) +CST2*E2(2) + CST3*E3(2)
      PNEW(3) = CST1*E1(3) +CST2*E2(3) + CST3*E3(3)

      END

C ================================================================== 

      SUBROUTINE ISNAN(VAL,IE)
C SI VAL(*) EST NAN RENVOI DANS VAL(*) LE VECTEUR NUL
      INTEGER IE,N
      DOUBLE PRECISION VAL(3),XEROR
      XEROR=SQRT(ABS(VAL(1)+VAL(2)+VAL(3)))
C X DOUBLE PRECISION : N = ID_ISNAN(X) RENVOIE 1 SI X EST NAN, 0 SINON
      N = ID_ISNAN(XEROR)
      IF (N.EQ.1) THEN
        WRITE(*,*)'WARNING ELEMENT ',IE,'LE RESULTAT EST NAN'
        DO 10 J=1,3
10        VAL(J)=0.D0 
      ENDIF 
      END
