      SUBROUTINE FCNKL2(S,T,FN,V,P,AIM,PIN)
C
C STEPHANE BALAC -- IRMAR -- JUIN 1995
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
C SOIT  UN TRIANGLE COURBE K DE R DE SOMMETS {V1,V2,V3} ET AYANT POUR 
C NOEUDS LES POINTS {V4,V5,V6.}
C SOIT P UN POINT DE R.
C ON RENVOI LA VALEUR DE L'INTEGRANT FN AU POINT (S,T) DU TRIANGLE  S DE 
C REFERENCE.
C
C   /                        /
C   |   R(P,Q) / R  DQ  =   |  FN(S,T) DS DT
C   / K                  |   / S
C                        |
C                   CHGT DE VARIABLES     
C 
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
C
      DOUBLE PRECISION P(3),PIN(3),V(3,6),FN(3),AIM(3),S,T,U
      DOUBLE PRECISION L(6),Q(3),DQS(3),DQT(3),NQ(3),VEC(3) 
      DOUBLE PRECISION JAC,KERNEL,PMQ1,PMQ2,PMQ3,SPT,RCUB,SUM,TEST,DSCAL    
      INTEGER I,J 
      DOUBLE PRECISION ZERO,ONE,TWO,THREE,FOUR
      PARAMETER (ZERO=0.0D0, ONE=1.0D0, TWO=2.0D0, THREE=3.0D0,
     *           FOUR=4.0D0)

C
C     CALCUL DES FONCTION DE BASE P2, L(*,S,T).
C
10    SPT = S + T
      U = ONE - SPT
      L(1) = U*(TWO*U - ONE)
      L(2) = T*(TWO*T - ONE)
      L(3) = S*(TWO*S - ONE)
      L(4) = FOUR*T*U
      L(5) = FOUR*S*T
      L(6) = FOUR*S*U
C
C CALCUL DE Q=Q(S,T) PAR INTERPOLATION QUADRATIQUE (CF FONCTION MK DU GUIDE).
C
      DO 20 I=1,3
	SUM = ZERO
	DO 15 J=1,6
15	  SUM = SUM + L(J)*V(I,J)
20	Q(I) = SUM
C
C CALCUL DE D_S M_K ET D_T M_K
C
	  DO 30 I=1,3
	    DQS(I) = (FOUR*SPT - THREE)*V(I,1) + (FOUR*S - ONE)*V(I,3)
     *	           + FOUR*(-T*V(I,4) + T*V(I,5) 
     *             + (ONE - T - TWO*S)*V(I,6))
30	    DQT(I) = (FOUR*SPT - THREE)*V(I,1) + (FOUR*T - ONE)*V(I,2)
     *	           + FOUR*((ONE - S - TWO*T)*V(I,4) 
     *             + S*V(I,5) - S*V(I,6))
C
C CALCUL DU JACOBIEN
C
	 JAC = DSQRT ((DQS(1)*DQT(2) - DQS(2)*DQT(1))**2
     *		    + (DQS(1)*DQT(3) - DQS(3)*DQT(1))**2
     *		    + (DQS(2)*DQT(3) - DQS(3)*DQT(2))**2)
C
C CALCUL DE LA NORMALE EXTERIEURE
C
       CALL DPDTVE(DQS,DQT,DQT,NQ,1)     
       CALL DVECT(PIN,Q,VEC,3) 
       TEST=DSCAL(NQ,VEC,VEC,3,2)
       IF (TEST.LT.0.D0) THEN
         DO 40 I=1,3
40         NQ(I)=-NQ(I)
       ENDIF       
       CALL DRNORM(NQ,NQ,3)
C
C CALCUL DE L'INTEGRAND
C
        PMQ1=P(1)-Q(1)
        PMQ2=P(2)-Q(2)
        PMQ3=P(3)-Q(3)
        RCUB=(DSQRT(PMQ1*PMQ1+PMQ2*PMQ2+PMQ3*PMQ3))**3
        KERNEL=( PMQ1*AIM(1)+PMQ2*AIM(2)+PMQ3*AIM(3) )/RCUB
      DO 50 I=1,3
50      FN(I)=KERNEL*NQ(I)*JAC

      END
