      SUBROUTINE FQE3P(VRINT,Q,P,Aim,Pin)
C     -----------------
C ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
C S. BALAC - 31 OCTOBRE 1997
C
C     CALCULATE THE INTEGRAL OF THE VECTOR-VALUED FUNCTION FCNKL(S,T) OF
C     LENGTH 3, DEFINED IN SUBROUTINE FCNKL, OVER THE UNIT SIMPLEX IN
C     THE PLANE. THE INTEGRATION USES THE ELEMENTARY 3 POINTS RULE OVER
C     THE UNIT SIMPLEX :
C     INT F(s,t) ds dt  APPROX (1/6) (F(S4) + F(S5) + F(S6))
C     WHERE F(Si) DENOTE THE MIDEPOINTS OF THE 3 EDGES OF THE SIMPLEX.
C ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      PARAMETER (ZERO=0.0D0,ONES=1.0D0,HALF=0.5D0,OVSIX=ONES/6.0D0)

      DIMENSION SM(3), TM(3), W(3), FN(3), VRINT(3) 
      DOUBLE PRECISION P(3),Q(3,6),Aim(3),Pin(3)

C     INITIALIZE NODES AND WEIGHTS
      SM(1) = HALF
      TM(1) = ZERO
      SM(2) = HALF
      TM(2) = HALF
      SM(3) = ZERO
      TM(3) = HALF
      W(1)  = OVSIX
      W(2)  = OVSIX
      W(3)  = OVSIX   
C
C     INITIALIZE VARIABLES FOR INTEGRATION LOOP.
      DO 25 L=1,3
25      VRINT(L) = ZERO

	  DO 30 K=1,3
	    CALL FCNKL2(SM(K),TM(K),FN,Q,P,Aim,Pin)
	    DO 40 L=1,3
40            VRINT(L) = VRINT(L) + W(K)*FN(L)
30      CONTINUE
      END
