      SUBROUTINE INTELM(P,Q0,QI,QJ,H,VARINT)
C STEPHANE BALAC -- IRMAR -- MAI 1995
C DERNIERE MODIFICATION : 24 MAI 1995
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
C CALCULS ELEMENTAIRES LIEES AU CALCULS DE L'INTEGRALE DE
C LA FONCTION VECTORIELLE #R/R^3 SUR LE TRIANGLE Q0,QI,QJ.
C 
C HBAR : COTE DE P DANS LE NOUVEAU REPERE
C SHBAR : SIGNE DE HBAR
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
      DOUBLE PRECISION P(3),Q0(3),QI(3),QJ(3),VAL(3),H,VARINT(3)
      DOUBLE PRECISION E1(3),E2(3),E3(3),P2D(2),XI,XJ,YJ
      DOUBLE PRECISION HBAR,SHBAR,F,G,DSCAL,DSIG
      DOUBLE PRECISION C1,C2,C3,B1,A1,A2,A3,V(3),VNORM
      INTEGER I,ISIGD       

C TEST SI LE TRIANGLE EST APLATI
      CALL DPDTVE(Q0,QI,QJ,V,2)
      VNORM=DSQRT(V(1)**2+V(2)**2+V(3)**2)
      IF (VNORM.LT.1D-10) THEN
        VARINT(1)=0.D0
        VARINT(2)=0.D0
        VARINT(3)=0.D0
        RETURN
      ENDIF
C
C CHANGEMENT DE SYSTEME DE COORDONNEES: {Q0,#E1,#E2,#E3} 
C OU #E1 = #(Q0-QI)/|Q0-QI| , #E3 = NORMALE A  (Q0,QI,QJ) ,
C    #E2 = #E3 ^ #E1
      CALL DVECT(Q0,QI,E1,3)
      CALL DRNORM(E1,E1,3)
      CALL DPDTVE(Q0,QI,QJ,E3,2)
      CALL DRNORM(E3,E3,3)
      CALL DPDTVE(E3,E1,E1,E2,1)
C  CALCUL DES COORDONNEES DES POINTS DANS CE REPERE     
      HBAR = DSCAL(Q0,P,E3,3,3)
      SHBAR= DSIG(ISIGD(HBAR))
      CALL DCHGRP(QI,Q0,E1,E2,P2D)
      XI=P2D(1)
C     YI = 0. !!!
      CALL DCHGRP(QJ,Q0,E1,E2,P2D)
      XJ=P2D(1)
      YJ=P2D(2)
C
C CALCUL DE L'INTEGRALE I1
C
      C1 = XJ/YJ
      C2 = (XJ-XI)/YJ
      C3 = XI
      B1 = YJ
      VAL(1) = F(H,C2,C3,B1) - F(H,C2,C3,0.D0) - F(H,C1,0.D0,B1) 
     &       + F(H,C1,0.D0,0.D0)
C
C CALCUL DE L'INTEGRALE I2
C
      A1 = YJ/(XJ-XI)
      A2 = - XI*YJ/(XJ-XI)
      A3 = YJ/XJ
      VAL(2) = F(H,A3,0.D0,XJ) - F(H,A3,0.D0,0.D0) + F(H,0.D0,0.D0,0.D0)
     &       + F(H,A1,A2,XI) - F(H,A1,A2,XJ) - F(H,0.D0,0.D0,XI)
C
C CALCUL DE L'INTEGRALE I3
C
       VAL(3) = G(H,C2,C3,B1) - G(H,C1,0.D0,B1)

      DO 20 I=1,3
20      VARINT(I) = E1(I)*VAL(1)+ E2(I)*VAL(2)+ SHBAR*E3(I)*VAL(3)
      END

C ==========================================================================
      DOUBLE PRECISION FUNCTION F(H,A,B,U)
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
C
C PRIMITIVE DE                   1
C                  ------------------------------------
C                      2       2              2    2 1/2
C                   ((A  + 1) U  + 2 A B U + H  + B )
C
C CODE MAPLE: ((A**2+1)*U**2+2*A*B*U+(H**2+B**2))**(-1/2);
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
      DOUBLE PRECISION H,A,B,U,T1,T2,T3,T4,T5,T6

      T1 = A*A+1
      T2 = DSQRT(T1)
      T3 = 2*A*B
      T4 = DSQRT(T1*U**2+T3*U+H**2+B**2)
      T5 = T3/(2*T2)
      T6  = DLOG(T4+T2*U+T5) / T2
      F=T6

      END

C ==========================================================================
      DOUBLE PRECISION FUNCTION G(H,A,B,YJ)
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
C INTEGRALE ENTRE 0 ET YJ  DE  
C
C                               H ( A Y + B )
C             ---------------------------------------------
C               2  2    2              2    2 1/2   2    2
C             (Y  A  + Y  + 2 A B Y + B  + H )    (Y  + H )
C
C CODE MAPLE: H*(A*Y+B)/(SQRT((A**2+1)*Y**2+2*A*B*Y+B**2+H**2)
C                      *(Y**2+H**2));
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
      DOUBLE PRECISION EPS,ATG
      PARAMETER(EPS=1.0D-09)
      DOUBLE PRECISION H,A,B,YJ,A2,H2,B2,YJ2
      DOUBLE PRECISION TJ,T0,T9,VALINT


      A2=A*A
      H2=H*H
      B2=B*B
      YJ2=YJ*YJ
  
      IF (ABS(A*B).GT.EPS) THEN
C     --------------------------
        TJ = A*(H2*A-B*YJ)/(B*(A*YJ+B))
        T0 = A2*H2/B2
        IF (A.GT.0.) THEN
          VALINT = -ATG(H,A,B,TJ)+ATG(H,A,B,T0)
        ELSE
          IF (YJ.LT.(-B/A)) THEN
            VALINT = ATG(H,A,B,TJ)-ATG(H,A,B,T0)
          ELSE
            VALINT = -ATG(H,A,B,TJ)-ATG(H,A,B,T0)
          ENDIF
        ENDIF

      ELSE
C     ---- 
C            CAS A*B=0 ===> A = 0 ET/OU B = 0
C  

      IF ((ABS(A).LT.EPS).AND.(ABS(B).LT.EPS)) THEN 
C                          CAS A = 0  ET B = 0
        VALINT = 0.D0
      ELSE
        IF (ABS(A).LT.EPS) THEN
C                          CAS A = 0  (NB. B POSITIF)
          VALINT = DATAN(1/DSQRT(YJ2+H2+B2)*YJ*B/H)               
        ELSE
CCCCCCCCIF (ABS(B).LT.EPS) THEN
C                          CAS B = 0  
         T9 = 1.D0/A2 
         VALINT =  DATAN(DSQRT(((A2+1)*YJ2+H2)/H2*T9))-DATAN(DSQRT(T9))
         VALINT = (A/DABS(A))*VALINT
       ENDIF
       ENDIF  
      ENDIF
      G=VALINT
      END


C ==========================================================================
      DOUBLE PRECISION FUNCTION ATG(H,A,B,T)
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
C                          2    2  2 1/2
C                        (B  + H  A )    T
C    ATG := ARCTAN(--------------------------------)
C                    /     2   2    2    2  2 \1/2
C                   | 2   A  (B  + H  + H  A )|
C                 H |T  + --------------------|
C                   |               2         |  
C                   \              B          /
C
C CODE MAPLE: G:= ARCTAN( (B^2  + H^2*  A^2 )^(1/2)   * T/ 
C                (H*(T^2+ A ^2 * (B^2   + H ^2  + H^2 *  A^2 )/B^2 )^(1/2)));
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
      IMPLICIT DOUBLE PRECISION (T)
      DOUBLE PRECISION H,A,B
      T1 = B*B
      T2 = H*H
      T3 = A*A
      T4 = T2*T3
      T9 = T*T
      T19 = DATAN(DSQRT(T1+T4)*T/H/DSQRT(T9+T3/T1*(T1+T2+T4)))
      ATG = T19

      END
c ==========================================================================
