      SUBROUTINE CBARY(P,Q1,Q2,Q3,L,NDIM)
C
C STEPHANE BALAC -- IRMAR -- MAI 1995
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
C CALCUL DES COORDONNEES BARYCENTRIQUES DE P RELATIVEMENT A  (Q1,Q2,Q3).
C NDIM = 2 : P,Q1,Q2,Q3 DANS R2.
C NDIM = 3 : P,Q1,Q2,Q3 COPLANAIRES DANS R3.
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
      INTEGER NDIM
      DOUBLE PRECISION P(NDIM),Q1(NDIM),Q2(NDIM),Q3(NDIM),L(NDIM)
      DOUBLE PRECISION X,X1,X2,X3,Y,Y1,Y2,Y3,DEN,A1,A2,B1,B2,C1,C2
C      DOUBLE PRECISION A3,B3,C3
      DOUBLE PRECISION E1(3),E2(3),E3(3),P2D(2),DDIST
     
      GOTO (20,30) (NDIM-1)
      STOP'ERROR 1 IN SB CBARY'	
C 
C CAS 2-D
C
20    X1=Q1(1)        
      X2=Q2(1)
      X3=Q3(1)
      X = P(1)
      Y1=Q1(2)   
      Y2=Q2(2)
      Y3=Q3(2)
      Y = P(2)
25    DEN=(-X3+X1)*Y2+(-X1+X2)*Y3+(X3-X2)*Y1
      A1=Y2-Y3
      B1=X3-X2
      C1=X2*Y3-X3*Y2
      L(1)=(A1*X+B1*Y+C1)/DEN
      A2=Y3-Y1
      B2=X1-X3
      C2=X3*Y1-X1*Y3
      L(2)=(A2*X+B2*Y+C2)/DEN
      L(3)= 1.D0-L(2)-L(1)
      RETURN
C
C CAS 3-D --> ON CONSIDERE UN REPERE LOCAL AU PLAN :{Q1, E1=Q1Q2, E3=N, E2=Z^X}
C
30    CALL DVECT(Q1,Q2,E1,3)
      CALL DRNORM(E1,E1,3)
      CALL DPDTVE(Q1,Q2,Q3,E3,2)
      CALL DRNORM(E3,E3,3)
      CALL DPDTVE(E3,E1,E1,E2,1)
      CALL DCHGRP(P,Q1,E1,E2,P2D)
      X=P2D(1)
      Y=P2D(2)
      X1=0.D0
      Y1=0.D0
      X2=DDIST(Q1,Q2,3)
      Y2=0.D0
      CALL DCHGRP(Q3,Q1,E1,E2,P2D)
      X3=P2D(1)
      Y3=P2D(2)
      GOTO 25

      END
C
C ############################################################################
C
      SUBROUTINE PROJEC(P,Q1,Q2,Q3,Q0,H)
C STEPHANE BALAC -- IRMAR -- MAI 1995
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
C CALCUL DE Q0 PROJETE ORTHOGONAL DE P SUR LE PLAN (Q1,Q2,Q3).
C RENVOI H = DIST(P,{Q1,Q2,Q3}).
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
      DOUBLE PRECISION P(3),Q1(3),Q2(3),Q3(3),Q0(3),N(3)
      DOUBLE PRECISION D,H,N1,N2,N3

      CALL DPDTVE(Q1,Q2,Q3,N,2)
      CALL DRNORM(N,N,3)
      N1=N(1)
      N2=N(2)
      N3=N(3)
      D = -N1*Q1(1)-N2*Q1(2)-N3*Q1(3)
      H = -(D + N1*P(1)+N2*P(2)+N3*P(3))
      Q0(1) = H*N1+P(1)
      Q0(2) = H*N2+P(2)
      Q0(3) = H*N3+P(3)
      H = DABS(H)
   
      END
